/************************************************************************
 * S T A N D A R D                                                      *
 ************************************************************************
 * Copyright (C) 2007 by                                                *
 * Dipl.-Ing. Michael Niederle                                          *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * For details of the GNU General Public License see                    *
 * http://www.gnu.org/copyleft/gpl.html                                 *
 * or write to the                                                      *
 * Free Software Foundation, Inc.,                                      *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *
 ************************************************************************/

#ifdef __INTEL_COMPILER
  #pragma warning(disable: 873 1011)
#else
  #pragma warning(disable: 4700)
#endif

typedef signed char         INT8;
typedef signed short        INT16;
typedef signed int          INT32;
typedef signed __int64      INT64;
typedef unsigned char       UINT8;
typedef unsigned short      UINT16;
typedef unsigned int        UINT32;
typedef unsigned __int64    UINT64;

typedef bool BOOLEAN;
typedef unsigned short WIDE_CHARACTER;
typedef long LONG;
typedef unsigned long ULONG;

#define INT8_MIN  -0x80
#define INT8_MAX   0x7f

#define UINT8_MIN  0
#define UINT8_MAX  0xffff

#define INT16_MIN -0x8000
#define INT16_MAX  0x7fff

#define UINT16_MIN 0
#define UINT16_MAX 0xffff

#define INT32_MIN -0x80000000i64
#define INT32_MAX  0x7fffffffi64

#define UINT32_MIN 0i64
#define UINT32_MAX 0xffffffffi64

typedef long NTSTATUS;

#define CHARACTER char
#define REAL double
//#define VOID void
#define MUTABLE mutable

#define IN
#define OUT

#define CONSTANT const

#define TYPE typedef

#define nil 0

#define NOT !
#define AND &&
#define OR ||

#define BEGIN {
#define END }

#define TEMPLATE template
#define CLASS class
#define RECORD struct
#define UNION union
#define ENUMERATION enum
#define PROCEDURE void

#ifdef __GNUC__
  #define TERMINATOR void __attribute__((noreturn))
#else
  #define TERMINATOR void _declspec(noreturn)
#endif

#define C_PROCEDURE extern "C" void
#define FUNCTION
#define C_FUNCTION extern "C"
#define OPERATOR operator
#define CONVERSION operator
#define CONSTRUCTOR
#define DESTRUCTOR
#define IS {
#define DEFERRED =0;
#define INLINE inline
#define VIRTUAL virtual
#define FRIEND friend

#define EXTERN extern
#define STATIC static
#define VOLATILE volatile

#define PUBLIC public
#define PROTECTED protected
#define PRIVATE private
#define PART :

#define CODE __asm{

#define raise(error) throw error;

#define TRY\
  BEGIN\
    try{

#define CATCH\
  END catch(

#define UNWIND\
  )\
  BEGIN

#define ENDTRY }}

#define rethrow throw;

#define IF if(
#define THEN ){
#define ELIF }else if(
#define ELSE }else{
#define FI }

#define ON if(
#define RETURN )return
#define GOTO )goto
#define EXIT )break;
#define AGAIN )continue;
#define THROW )throw
#define RETHROW )rethrow;
#define RAISE )raise
#define FAIL )fail

#define SELECT switch(
#define FROM ){
#define CASE break;case
#define OTHERWISE break;default:

#define WHILE while(
#define DO ){

#define REPEAT do{
#define UNTIL }while(!(
#define ENDREP ));

#define LOOP while(true){

#define For(_idx,from,till) for(_idx=from;_idx<(till+1);++_idx
#define FOR(_idx,from,till) for(INT _idx=from;_idx<(till+1);++_idx
#define ForStep(_idx,from,till,step) for(_idx=from;_idx<=(till);_idx+=step
#define FOR_STEP(_idx,from,till,step) for(INT _idx=from;_idx<=(till);_idx+=step
#define ForDown(_idx,from,till) for(_idx=from;_idx>=(till);--_idx
#define FOR_DOWN(_idx,from,till) for(INT _idx=from;_idx>=(till);--_idx
#define ForDownStep(_idx,from,till,step) for(_idx=from;_idx>=(till);_idx-=step
#define FOR_DOWN_STEP(_idx,from,till,step)\
  for(INT _idx=from;_idx>=(till);_idx-=step
#define ForTimes(number) for(INT32 _idx=(number);_idx>0;--_idx
#define ForEachListEntry(p,list,link) for((p)=(list);(p);(p)=(p)->link
#define NEXT }

#define _anonymous_name3(line) _anonymous_##line
#define _anonymous_name2(line) _anonymous_name3(line)
#define _anonymous_name _anonymous_name2(__LINE__)

#ifndef offsetof
  #define offsetof(s,c) ((INT32)(&((s*)0)->c))
#endif

#define dim(f) (sizeof(f)/sizeof*(f))

#define itemsizeof(f) (sizeof*(f))

#define INC_FP(fp,off) (*(INT8 **)(&fp)=(INT8 *)(fp)+(off))
#define DEC_FP(fp,off) (*(INT8 **)(&fp)=(INT8 *)(fp)-(off))

TEMPLATE <CLASS T>
INLINE PROCEDURE swap(T &left, T &right) IS
  T tmp;
  tmp = left;
  left = right;
  right = tmp;
END

#ifndef min
  #define min(a,b) ((a)<(b)?(a):(b))
#endif
#ifndef max
  #define max(a,b) ((a)>(b)?(a):(b))
#endif

#define update(x,v) ((x)!=(v)?(x)=(v),true:false)
#define cond_assign(p,v) IF (p) THEN *(p)=(v); FI
#define extend_to(x,y) if((x)<(y))(x)=(y)
#define reduce_to(x,y) if((x)>(y))(x)=(y)
#define div2(x,y) ((x)>=0?(x)/(y):((x)+1)/(y)-1)
#define mod2(x,y) ((x)>=0?(x)%(y):((x)+1)%(y)+(y)-1)
   /* x and y may not cause side effects */

#define btst(b,x) ((x>>b)&1)

#ifdef __GNUC__
 #define QuadConstant(c) c##LL
#else
 #define QuadConstant(c) c##i64
#endif

#define BEGIN_INITIALIZATION\
  RECORD _anonymous_name IS\
    INLINE CONSTRUCTOR _anonymous_name() IS

#define END_INITIALIZATION\
    END\
  END _anonymous_name;
